﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace K16DIOSample
{
    public partial class DevForm : Form
    {
        public short DevId;                     //Device Id

        private Boolean ChangeEn;       // 出力操作の可不可
        //チェックボックスコントロール用配列を作成
        private System.Windows.Forms.CheckBox[] P1OUT;
        private System.Windows.Forms.CheckBox[] P2OUT;
        //ラベルコントロール用配列を作成
        private System.Windows.Forms.Label[] P1ST;
        private System.Windows.Forms.Label[] P2ST;

        public DevForm()
        {
            InitializeComponent();
            //チェックボックスのインスタンスを配列にコピーして配列化する
            this.P1OUT = new System.Windows.Forms.CheckBox[]
                {this.P1OUT0, this.P1OUT1, this.P1OUT2, this.P1OUT3,
                this.P1OUT4, this.P1OUT5, this.P1OUT6, this.P1OUT7};
            this.P2OUT = new System.Windows.Forms.CheckBox[]
                {this.P2OUT0, this.P2OUT1, this.P2OUT2, this.P2OUT3, 
                this.P2OUT4, this.P2OUT5, this.P2OUT6, this.P2OUT7};
            //ラベルコントロールのインスタンスを配列にコピーして配列化する
            this.P1ST = new System.Windows.Forms.Label[]
                {this.P1ST0, this.P1ST1, this.P1ST2, this.P1ST3, 
                this.P1ST4, this.P1ST5, this.P1ST6, this.P1ST7};
            this.P2ST = new System.Windows.Forms.Label[]
                {this.P2ST0, this.P2ST1, this.P2ST2, this.P2ST3, 
                this.P2ST4, this.P2ST5, this.P2ST6, this.P2ST7};
        }

        public void SetId(short Id)
        {
            short retErr;
            byte[] Dir = new byte[2];
            byte Bit;
            byte[] DOUTStatus = new byte[2];

            DevId = Id;

            this.Text = "ID = " + DevId.ToString() + "  Panel";
            retErr = TUSBKDIO.TUSBK16DIO_DirRead(DevId, out Dir[0], out Dir[1]);
            if( retErr != 0 )
            {
                MessageBox.Show(TUSBKDIO.GetErrMessage(retErr));
                this.Close();
                return;
            }

            P1IOSEL1.Checked = (Dir[0] == 0);
            P1IOSEL2.Checked = (Dir[0] != 0);
            P2IOSEL1.Checked = (Dir[1] == 0);
            P2IOSEL2.Checked = (Dir[1] != 0);

            retErr = TUSBKDIO.TUSBK16DIO_OutputRead(DevId, out DOUTStatus[0], out DOUTStatus[1]);
            if( retErr != 0)
            {
                MessageBox.Show(TUSBKDIO.GetErrMessage(retErr));
                this.Close();
                return;
            }

            ChangeEn = false;
            for( Bit = 0 ; Bit < 8 ; Bit ++ )
            {
                P1OUT[Bit].Checked = (DOUTStatus[0] & (byte) Math.Pow(2,Bit)) != 0;
                P2OUT[Bit].Checked = (DOUTStatus[1] & (byte) Math.Pow(2,Bit)) != 0;
            }
            ChangeEn = true;

            IoCheck();

            Timer1.Interval = 100;
            Timer1.Enabled = true;
        }

        private void IoCheck()
        {
            short retErr;
            byte Data1;
            byte Data2;
            short Bit;
            short Mask;
            
            retErr = TUSBKDIO.TUSBK16DIO_Read(DevId, out Data1, out Data2);

            Mask = 1;

            for( Bit = 0 ; Bit < 8 ; Bit ++ )
            {
                if( ( Data1 & Mask ) != 0 )
                    P1ST[Bit].Text = "High";
                else
                    P1ST[Bit].Text = "Low";

                if( ( Data2 & Mask ) != 0 )
                    P2ST[Bit].Text = "High";
                else
                    P2ST[Bit].Text = "Low";

                Mask *= 2;
            }
        }

        private void P1IOSEL_CheckedChanged(object sender, EventArgs e)
        {
            short retErr;

            if (P1IOSEL1.Checked)
                retErr = TUSBKDIO.TUSBK16DIO_Dir(DevId, 0, 0);
            else
                retErr = TUSBKDIO.TUSBK16DIO_Dir(DevId, 0, 1);

            if (retErr != 0)
                MessageBox.Show(TUSBKDIO.GetErrMessage(retErr));
        }

        private void P2IOSEL_CheckedChanged(object sender, EventArgs e)
        {
            short retErr;

            if (P2IOSEL1.Checked)
                retErr = TUSBKDIO.TUSBK16DIO_Dir(DevId, 1, 0);
            else
                retErr = TUSBKDIO.TUSBK16DIO_Dir(DevId, 1, 1);

            if (retErr != 0)
                MessageBox.Show(TUSBKDIO.GetErrMessage(retErr));
        }

        private void P1OUT_Changed()
        {
            short retErr;
            int index;
            byte tmpB;


            tmpB = 0;
            for (index = 0; index < 8; index++)
            {
                if (P1OUT[index].CheckState == CheckState.Checked)
                    tmpB += (byte) Math.Pow(2, index);
            }

            retErr = TUSBKDIO.TUSBK16DIO_PortWrite(DevId, 0, tmpB);

            if (retErr != 0)
                MessageBox.Show(TUSBKDIO.GetErrMessage(retErr));
        }

        private void P2OUT_Changed()
        {
            short retErr;
            int index;
            byte tmpB;


            tmpB = 0;
            for (index = 0; index < 8; index++)
            {
                if (P2OUT[index].CheckState == CheckState.Checked)
                    tmpB += (byte)Math.Pow(2, index);
            }

            retErr = TUSBKDIO.TUSBK16DIO_PortWrite(DevId, 1, tmpB);

            if (retErr != 0)
                MessageBox.Show(TUSBKDIO.GetErrMessage(retErr));
        }

        private void P1OUT_CheckStateChanged(object sender, EventArgs e)
        {
            if( ChangeEn )
                P1OUT_Changed();
        }

        private void P2OUT_CheckStateChanged(object sender, EventArgs e)
        {
            if( ChangeEn )
                P2OUT_Changed();
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            IoCheck();
        }
    }
}
