﻿//-----------------------------------------------
//TUSB-K16DIO用ドライバアクセス用API
//Visual C# 用モジュール
//
//2014_01_09　株式会社タートル工業
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;

class TUSBKDIO
{
    //API Function declaration
    [DllImport("TUSBKDIO.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK16DIO_Device_Open(short Id);
    [DllImport("TUSBKDIO.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void TUSBK16DIO_Device_Close(short Id);
    [DllImport("TUSBKDIO.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK16DIO_Dir(short Id, byte Port, byte Directin);
    [DllImport("TUSBKDIO.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK16DIO_PortWrite(short Id, byte Port, byte data);
    [DllImport("TUSBKDIO.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK16DIO_Write(short Id, byte Data1, byte Data2);
    [DllImport("TUSBKDIO.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK16DIO_Read(short Id, out byte Data1, out byte Data2);
    [DllImport("TUSBKDIO.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK16DIO_DirRead(short Id, out byte Dir1, out byte Dir2);
    [DllImport("TUSBKDIO.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short TUSBK16DIO_OutputRead(short Id, out byte Data1, out byte Data2);
    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }
}

