﻿Public Class DevForm
    Inherits System.Windows.Forms.Form

    Private DevId As Integer         'Device Id

    Private ChangeEn As Boolean     '出力操作の可不可
    'チェックボックスコントロール用配列を作成
    Private P1OUT() As System.Windows.Forms.CheckBox
    Private P2OUT() As System.Windows.Forms.CheckBox
    'ラベルコントロール用配列を作成
    Private P1ST() As System.Windows.Forms.Label
    Private P2ST() As System.Windows.Forms.Label

    'This Form module initialize
    Public Sub SetId(ByVal Id As Short)
        Dim retErr As Integer
        Dim Dir(1) As Byte
        Dim Bit As Byte
        Dim DOUTStatus(1) As Byte

        DevId = Id

        Me.Text = "ID = " + DevId.ToString() + "  Panel"

        retErr = TUSBK16DIO_DirRead(DevId, Dir(0), Dir(1))
        If retErr Then
            TUSBK02AD_ErrorDisp(retErr)
            Me.Close()
            Exit Sub
        End If

        P1IOSEL1.Checked = (Dir(0) = 0)
        P1IOSEL2.Checked = (Dir(0) <> 0)
        P2IOSEL1.Checked = (Dir(1) = 0)
        P2IOSEL2.Checked = (Dir(1) <> 0)

        retErr = TUSBK16DIO_OutputRead(DevId, DOUTStatus(0), DOUTStatus(1))
        If retErr Then
            TUSBK02AD_ErrorDisp(retErr)
            Me.Close()
            Exit Sub
        End If

        ChangeEn = False
        For Bit = 0 To 7
            P1OUT(Bit).Checked = (DOUTStatus(0) And (2 ^ Bit)) <> 0
            P2OUT(Bit).Checked = (DOUTStatus(1) And (2 ^ Bit)) <> 0
        Next Bit
        ChangeEn = True

        IoCheck()

        Timer1.Interval = 100
        Timer1.Enabled = True
    End Sub

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。
        'チェックボックスのインスタンスを配列にコピーして配列化する
        Me.P1OUT = New System.Windows.Forms.CheckBox() _
            {Me.P1OUT0, Me.P1OUT1, Me.P1OUT2, Me.P1OUT3, _
            Me.P1OUT4, Me.P1OUT5, Me.P1OUT6, Me.P1OUT7}
        Me.P2OUT = New System.Windows.Forms.CheckBox() _
            {Me.P2OUT0, Me.P2OUT1, Me.P2OUT2, Me.P2OUT3, _
            Me.P2OUT4, Me.P2OUT5, Me.P2OUT6, Me.P2OUT7}
        'ラベルコントロールのインスタンスを配列にコピーして配列化する
        Me.P1ST = New System.Windows.Forms.Label() _
            {Me.P1ST0, Me.P1ST1, Me.P1ST2, Me.P1ST3, _
            Me.P1ST4, Me.P1ST5, Me.P1ST6, Me.P1ST7}
        Me.P2ST = New System.Windows.Forms.Label() _
            {Me.P2ST0, Me.P2ST1, Me.P2ST2, Me.P2ST3, _
            Me.P2ST4, Me.P2ST5, Me.P2ST6, Me.P2ST7}
    End Sub

    Private Sub IoCheck()
        Dim retErr As Short
        Dim Data1 As Byte
        Dim Data2 As Byte
        Dim Bit As Short
        Dim Mask As Short

        retErr = TUSBK16DIO_Read(DevId, Data1, Data2)

        Mask = 1

        For Bit = 0 To 7
            If Data1 And Mask Then
                P1ST(Bit).Text = "High"
            Else
                P1ST(Bit).Text = "Low"
            End If

            If Data2 And Mask Then
                P2ST(Bit).Text = "High"
            Else
                P2ST(Bit).Text = "Low"
            End If

            Mask *= 2
        Next Bit
    End Sub

    Private Sub P1IOSEL_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles P1IOSEL1.CheckedChanged, P1IOSEL2.CheckedChanged
        Dim retErr As Short

        If P1IOSEL1.Checked Then
            retErr = TUSBK16DIO_Dir(DevId, 0, 0)
        Else
            retErr = TUSBK16DIO_Dir(DevId, 0, 1)
        End If

        If retErr <> 0 Then
            TUSBK02AD_ErrorDisp(retErr)
        End If
    End Sub

    Private Sub P2IOSEL_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles P2IOSEL1.CheckedChanged, P2IOSEL2.CheckedChanged
        Dim retErr As Short

        If P2IOSEL1.Checked Then
            retErr = TUSBK16DIO_Dir(DevId, 1, 0)
        Else
            retErr = TUSBK16DIO_Dir(DevId, 1, 1)
        End If

        If retErr <> 0 Then
            TUSBK02AD_ErrorDisp(retErr)
        End If
    End Sub
    Private Sub P1OUT_Changed()
        Dim retErr As Short
        Dim index As Integer
        Dim tmpB As Byte

        tmpB = 0
        For index = 0 To 7
            If P1OUT(index).CheckState = CheckState.Checked Then
                tmpB += 2 ^ index
            End If
        Next

        retErr = TUSBK16DIO_PortWrite(DevId, 0, tmpB)

        If retErr Then
            TUSBK02AD_ErrorDisp(retErr)
        End If
    End Sub

    Private Sub P2OUT_Changed()
        Dim retErr As Short
        Dim index As Integer
        Dim tmpB As Byte

        tmpB = 0
        For index = 0 To 7
            If P2OUT(index).CheckState = CheckState.Checked Then
                tmpB += 2 ^ index
            End If
        Next

        retErr = TUSBK16DIO_PortWrite(DevId, 1, tmpB)

        If retErr Then
            TUSBK02AD_ErrorDisp(retErr)
        End If
    End Sub

    Private Sub P1OUT_CheckStateChanged(sender As System.Object, e As System.EventArgs) Handles P1OUT0.CheckStateChanged, P1OUT7.CheckStateChanged, P1OUT6.CheckStateChanged, P1OUT5.CheckStateChanged, P1OUT4.CheckStateChanged, P1OUT3.CheckStateChanged, P1OUT2.CheckStateChanged, P1OUT1.CheckStateChanged
        If ChangeEn Then
            P1OUT_Changed()
        End If
    End Sub

    Private Sub P2OUT_CheckStateChanged(sender As System.Object, e As System.EventArgs) Handles P2OUT0.CheckStateChanged, P2OUT7.CheckStateChanged, P2OUT6.CheckStateChanged, P2OUT5.CheckStateChanged, P2OUT4.CheckStateChanged, P2OUT3.CheckStateChanged, P2OUT2.CheckStateChanged, P2OUT1.CheckStateChanged
        If ChangeEn Then
            P2OUT_Changed()
        End If
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        IoCheck()
    End Sub
End Class