'-----------------------------------------------
'API for TUSB-K16DIO Driver
'Visual Basic Module
'
'Apr. 23 2012
'Copyright (C) 2012 Turtle Industry Co.,Ltd.
'-----------------------------------------------
Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices
Module TUSBKDIO

    'API Function declaration
    <DllImport("TUSBKDIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK16DIO_Device_Open(ByVal Id As Short) _
                        As Short
    End Function
    <DllImport("TUSBKDIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub TUSBK16DIO_Device_Close(ByVal Id As Short)
    End Sub
    <DllImport("TUSBKDIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK16DIO_Dir(ByVal Id As Short, _
                            ByVal Port As Byte, _
                            ByVal Direction As Byte) _
                        As Short
    End Function
    <DllImport("TUSBKDIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK16DIO_PortWrite(ByVal Id As Short, _
                                  ByVal Port As Byte, _
                                  ByVal data As Byte) _
                              As Short
    End Function
    <DllImport("TUSBKDIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK16DIO_Write(ByVal Id As Short, _
                              ByVal Data1 As Byte, _
                              ByVal Data2 As Byte) _
                          As Short
    End Function
    <DllImport("TUSBKDIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK16DIO_Read(ByVal Id As Short, _
                             ByRef Data1 As Byte, _
                             ByRef Data2 As Byte) _
                         As Short
    End Function
    <DllImport("TUSBKDIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK16DIO_DirRead(ByVal Id As Short, _
                                ByRef Dir1 As Byte, _
                                ByRef Dir2 As Byte) _
                            As Short
    End Function
    <DllImport("TUSBKDIO.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSBK16DIO_OutputRead(ByVal Id As Short, _
                                   ByRef Data1 As Byte, _
                                   ByRef Data2 As Byte) _
                               As Short
    End Function

    ' Error Message
    Public Sub TUSBK02AD_ErrorDisp(ByVal ErrCode As Short)
        Dim tmpStr As String

        Select Case ErrCode
            Case 0
                tmpStr = "ɏI܂"
            Case 1
                tmpStr = "IDԍsł"
            Case 2
                tmpStr = "hCoĂ܂"
            Case 3
                tmpStr = "łɃfoCX̓I[vĂ܂"
            Case 4
                tmpStr = "ڑĂ䐔܂"
            Case 5
                tmpStr = "I[vł܂ł"
            Case 6
                tmpStr = "foCX܂ł"
            Case 8
                tmpStr = "p[^G["
            Case 9
                tmpStr = "USBʐMG["
            Case Else
                tmpStr = "sȃG[ł"
        End Select

        MsgBox(tmpStr)
    End Sub
End Module